/*
 * SymbolFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef SYMBOL_FROM_STRING_LEXER_H_
#define SYMBOL_FROM_STRING_LEXER_H_

#include <string>
#include <istream>

namespace alphabet {

class SymbolFromStringLexer {
public:
	enum class TokenType {
		BLANK,
		BOTTOM,
		END,
		START,
		TEOF,
		ERROR,
	};

	struct Token {
		TokenType type;
		std::string value;
		std::string raw;
	};

	Token next(std::istream& input) const;
	void putback(std::istream&, Token token) const;
};

} /* namespace alphabet */

#endif /* SYMBOL_FROM_STRING_LEXER_H_ */
